
#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <gl/glut.h>


#define NORMAL		0
#define ESTEREO		1
#define ANTIALIAS	2
#define ESTELA		3
#define ESTEREO2	4


#define DOCULAR 0.04
#include "geom_aux.c"

#define DEG2RAD (3.14159/180.0)

#define TABLE_TEXTURE "brick.rgb"

#define MAX_OBJECTS 2

static GLint table_list;
static GLint objects_list[MAX_OBJECTS];

static GLfloat xrot, yrot=0;
static GLfloat spin;
	float tetera[8][3]={{2,0,0},{0,0,2},{-2,0,0},{0,0,-2},
					{1.4,0,-1.40},{-1.4,0,1.4},{-1.4,0,-1.40},{1.4,0,1.4},};

float obs[3]={0,1,4};
float ref[3]={0,0,0};

char vista_tio=0;
char eje_aspect=1;
char frustrum=0;
char tipo_escena=NORMAL;
float aspecto;
int sx,sy;
float fov=60;
float posf=0;
float delta_tiempo=0.1;
static GLfloat light_pos[] =
{0.0, 20.0, 0.0, 1.0};
static void draw_scene(void);
static void draw_scene_estereo(void);
static void draw_scene_antialias(void);
static void draw_scene_estela(void);
static void draw_scene_estereo2(void);

float vec_desp[8][2]=
{
   {0.5625, 0.4375}, {0.0625, 0.9375}, {0.3125, 0.6875}, {0.6875, 0.8125},
   {0.8125, 0.1875}, {0.9375, 0.5625}, {0.4375, 0.0625}, {0.1875, 0.3125}
};
float vec_desp2[4][2]=
{
    {0.375, 0.25}, {0.125, 0.75}, {0.875, 0.25}, {0.625, 0.75}
};
float vec_desp3[16][2]=
{
{0.375, 0.4375}, {0.625, 0.0625}, {0.875, 0.1875}, {0.125, 0.0625},
{0.375, 0.6875}, {0.875, 0.4375}, {0.625, 0.5625}, {0.375, 0.9375},
{0.625, 0.3125}, {0.125, 0.5625}, {0.125, 0.8125}, {0.375, 0.1875},
{0.875, 0.9375}, {0.875, 0.6875}, {0.125, 0.3125}, {0.625, 0.8125}
};




static void 
init(void)
{



 glEnable(GL_CULL_FACE);

  glShadeModel(GL_FLAT);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);

 
 glClearColor(0.0, 0.0, 0.0, 1.0);
  glClearAccum(0,0,0,1);
  glEnable(GL_NORMALIZE);
}
void desplaza_frustum_antialias(float l,float r,float b,float t, float n ,float f,float x,float y)
{
    GLfloat scalex, scaley;
    GLint viewport[4];

    glGetIntegerv(GL_VIEWPORT,(GLint *)viewport);
   // scalex = (r - l)/viewport[2];
   // scaley = (t - b)/viewport[3];
	scalex = (r - l)/sx;
    scaley = (t - b)/sy;

   glFrustum(l - x * scalex,r - x * scalex,b - y * scaley,t - y * scaley,n,f);
//	glFrustum(l,r,b,y,n,f);
}


void actualiza_perspectiva(  )
{
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
  //glFrustum(-aspect, aspect, -1.0, 1.0, 4.0, 300.0);
	if(frustrum)
		glFrustum((-0.7)+posf,0.7+posf,-0.7,0.7,1,40);
	else{
	
	if(eje_aspect)
		gluPerspective(fov,aspecto,0.1,40);
	else
	   gluPerspective(fov,1,0.1,40);
	}
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}	

static void
reshape(int w, int h)
{
  GLfloat aspect = (float) w / (float) h;
    aspecto=aspect;
	sx=w;sy=h;
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //glFrustum(-aspect, aspect, -1.0, 1.0, 4.0, 300.0);
	if(eje_aspect)
		gluPerspective(fov,aspect,0.1,40);
	else
	   gluPerspective(fov,1,0.1,40);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void TrayectoriaTetera(float *punto,float *vec,float inct)
{
float radio;
float ang;
float aux[3]={0,1,0};

		punto[1]=0;
		radio=m_module3D(punto);

		ang=atan2(punto[2],punto[0]);

		ang+=0.5*inct;

		punto[0]=radio*cos(ang);
		punto[2]=radio*sin(ang);

		m_vector_prod_3D(punto,aux,vec);
		m_normalize3D(vec);

		punto[1]=0.5*(1+cos(3*ang));
};
		
void dibuja_lineas_teteras(void)
{
float aux[3]={0,0,0};
int i;
	glDisable(GL_LIGHTING);
	glLineWidth(3);
	for(i=0;i<8;i++)
	{
		glColor3f(0,0.5,0.8);
		glBegin(GL_LINES);
			glVertex3fv(aux);
			glVertex3fv(tetera[i]);
		glEnd();
	}
    glColor3f(0.5,0,0);
	glBegin(GL_POLYGON);

		glVertex3f(2.5,-0.25,2.5);
		glVertex3f(-2.5,-0.250,2.5);
		glVertex3f(-2.5,-0.250,-2.5);
		glVertex3f(2.5,-0.250,-2.5);
   glEnd();

	glEnable(GL_LIGHTING);
}	

void dibuja_tetera(int j,int material)
{
	GLfloat mt[4][4]={
		{0.7,0.7,0.0,0},
		{-0.7,0.7,0,0},
		{0,0,1,0},
		{1,1,0,1}};
	GLfloat vecx[3]={1,0,0};
	GLfloat vecy[3]={0,1,0};
	GLfloat vecz[3]={0,0,1};
  GLfloat mat[4][3]= {
	{0,0,1},
	{0,1,0},
	{1,0,0},
	{1,1,0}};
	int i;

		glPushMatrix();
            glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat[material]);
			TrayectoriaTetera(tetera[j],vecx,delta_tiempo);
 			m_vector_prod_3D(vecx,vecy,vecz);
			for(i=0;i<3;i++)
			{
   				 	mt[0][i]=vecx[i];
					mt[1][i]=vecy[i];
					mt[2][i]=vecz[i];
					mt[3][i]=tetera[j][i];

			}
			glMultMatrixf((GLfloat*)mt);
  		
      		glutSolidTeapot(0.25);
		glPopMatrix();


}
void dibuja_tetera2(int j,int material)
{
	GLfloat mt[4][4]={
		{0.7,0.7,0.0,0},
		{-0.7,0.7,0,0},
		{0,0,1,0},
		{1,1,0,1}};
	GLfloat vecx[3]={1,0,0};
	GLfloat vecy[3]={0,1,0};
	GLfloat vecz[3]={0,0,1};
  GLfloat mat[4][3]= {
	{0,0,1},
	{0,1,0},
	{1,0,0},
	{1,1,0}};
	int i;
	float ang;

		glPushMatrix();
            glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat[material]);
			TrayectoriaTetera(tetera[j],vecx,delta_tiempo);
 
			glTranslatef(tetera[j][0],tetera[j][1],tetera[j][2]);
			ang=atan2(vecx[0],vecx[2]);
		     glRotatef(ang*57-90,0,1,0);
      		glutSolidTeapot(0.25);
		glPopMatrix();


}

void dibuja_tetera_st(int j,int material)
{
	GLfloat mt[4][4]={
		{0.7,0.7,0.0,0},
		{-0.7,0.7,0,0},
		{0,0,1,0},
		{1,1,0,1}};
	GLfloat vecx[3]={1,0,0};
	GLfloat vecy[3]={0,1,0};
	GLfloat vecz[3]={0,0,1};
  GLfloat mat[4][3]= {
	{0,0,1},
	{0,1,0},
	{1,0,0},
	{1,1,0}};
	int i;
	float ang;

		glPushMatrix();
            glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat[material]);
			TrayectoriaTetera(tetera[j],vecx,0.0);
 	
			glTranslatef(tetera[j][0],tetera[j][1],tetera[j][2]);
			ang=atan2(vecx[0],vecx[2]);
		     glRotatef(ang*57-90,0,1,0);
      		glutSolidTeapot(0.25);
		glPopMatrix();


}

void draw_scene_general()
{
	switch(tipo_escena)
	{
	case NORMAL:
		draw_scene();
		break;
	case ESTEREO:
		draw_scene_estereo();
		break;
	case ANTIALIAS:
		draw_scene_antialias();
		break;
	case ESTELA:
		draw_scene_estela();
		break;
	case ESTEREO2:
		draw_scene_estereo2();
		break;


	}
}

static void 
draw_scene_estereo(void)
{
  GLfloat dist = 5.0;
  GLfloat eyex, eyey, eyez;
  GLfloat mat[4][3]= {
	{0,0,1},
	{0,1,0},
	{1,0,0},
	{1,1,0}};
	GLfloat mivista[16]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
    GLfloat m2[4][4]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
	GLfloat mt[4][4]={
		{0.7,0.7,0.0,0},
		{-0.7,0.7,0,0},
		{0,0,1,0},
		{1,1,0,1}};
	GLfloat vecx[3]={1,0,0};
	GLfloat vecy[3]={0,1,0};
	GLfloat vecz[3]={0,0,1};
	GLfloat tras[3]={1,0,0};

	
  int i,j;

 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

	glEnable(GL_DEPTH_TEST);
	 glColorMask(GL_TRUE,GL_FALSE,GL_FALSE,GL_TRUE);
  	glPushMatrix();
    	if(!vista_tio)
		{
		
			gluLookAt(obs[0]-DOCULAR,obs[1],obs[2],ref[0],ref[1], ref[2]+1.5, 0.0, 1.0, 0.0);

		}
		else
		{
		TrayectoriaTetera(tetera[0],vecx,delta_tiempo);
		
        m_vector_prod_3D(vecx,vecy,vecz);
			for(i=0;i<3;i++)
			{
   				 	mt[i][0]=vecz[i];
					mt[i][1]=vecy[i];
					mt[i][2]=-vecx[i];
					mt[3][i]=0;
					m2[3][i]=-tetera[0][i];

			}
		  glMultMatrixf((GLfloat*)mt);
		  glMultMatrixf((GLfloat*)m2);
		  }
          glGetFloatv(GL_MODELVIEW_MATRIX,(GLfloat *)m2);
		/*	printf("\nMatrizVision \n");
			for(i=0;i<4;i++)
			{

				printf("\n");
				for(j=0;j<4;j++)	
				printf("%f\t",m2[j][i]);

			}*/
	glDisable(GL_CULL_FACE);	
 		glShadeModel(GL_FLAT);
	

		if(!vista_tio)
		dibuja_tetera(0,0);
		dibuja_tetera2(1,1);
  		dibuja_tetera(2,2);
 		dibuja_tetera(3,3);
 		dibuja_tetera(4,1);
  		dibuja_tetera(5,2);
 		dibuja_tetera(6,3);
  		dibuja_tetera(7,2);
  		
        dibuja_lineas_teteras();
  	glPopMatrix();

	glClear(GL_DEPTH_BUFFER_BIT);
	
glColorMask(GL_FALSE,GL_TRUE,GL_TRUE,GL_TRUE);

 
	glPushMatrix();
    	if(!vista_tio)
		{
		
			gluLookAt(obs[0]+DOCULAR,obs[1],obs[2],ref[0],ref[1], ref[2]+1.5, 0.0, 1.0, 0.0);

		}
		else
		{
		TrayectoriaTetera(tetera[0],vecx,0.4);
		
        m_vector_prod_3D(vecx,vecy,vecz);
			for(i=0;i<3;i++)
			{
   				 	mt[i][0]=vecz[i];
					mt[i][1]=vecy[i];
					mt[i][2]=-vecx[i];
					mt[3][i]=0;
					m2[3][i]=-tetera[0][i];

			}
		  glMultMatrixf((GLfloat*)mt);
		  glMultMatrixf((GLfloat*)m2);
		  }
          glGetFloatv(GL_MODELVIEW_MATRIX,(GLfloat *)m2);
	glDisable(GL_CULL_FACE);	
 		glShadeModel(GL_FLAT);

		if(!vista_tio)
		dibuja_tetera_st(0,0);
		dibuja_tetera_st(1,1);
  		dibuja_tetera_st(2,2);
 		dibuja_tetera_st(3,3);
 		dibuja_tetera_st(4,1);
  		dibuja_tetera_st(5,2);
 		dibuja_tetera_st(6,3);
  		dibuja_tetera_st(7,2);
  		
        dibuja_lineas_teteras();
  	glPopMatrix();
glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);

  glutSwapBuffers();

}

static void 
draw_scene_estereo2(void)
{
  GLfloat dist = 5.0;
  GLfloat eyex, eyey, eyez;
  GLfloat mat[4][3]= {
	{0,0,1},
	{0,1,0},
	{1,0,0},
	{1,1,0}};
	GLfloat mivista[16]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
    GLfloat m2[4][4]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
	GLfloat mt[4][4]={
		{0.7,0.7,0.0,0},
		{-0.7,0.7,0,0},
		{0,0,1,0},
		{1,1,0,1}};
	GLfloat vecx[3]={1,0,0};
	GLfloat vecy[3]={0,1,0};
	GLfloat vecz[3]={0,0,1};
	GLfloat tras[3]={1,0,0};

	
  int i,j;

 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

	glEnable(GL_DEPTH_TEST);
	 glColorMask(GL_TRUE,GL_FALSE,GL_FALSE,GL_TRUE);

glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
		glFrustum((-0.7)+posf+0.04,0.7+posf+0.04,-0.7,0.7,1,40);
glMatrixMode(GL_MODELVIEW);
  	glPushMatrix();
    	if(!vista_tio)
		{
		
			gluLookAt(obs[0]-DOCULAR,obs[1],obs[2],ref[0]-DOCULAR,ref[1], ref[2]+1.5, 0.0, 1.0, 0.0);

		}
		else
		{
		TrayectoriaTetera(tetera[0],vecx,delta_tiempo);
		
        m_vector_prod_3D(vecx,vecy,vecz);
			for(i=0;i<3;i++)
			{
   				 	mt[i][0]=vecz[i];
					mt[i][1]=vecy[i];
					mt[i][2]=-vecx[i];
					mt[3][i]=0;
					m2[3][i]=-tetera[0][i];

			}
		  glMultMatrixf((GLfloat*)mt);
		  glMultMatrixf((GLfloat*)m2);
		  }
    
	glDisable(GL_CULL_FACE);	
 		glShadeModel(GL_FLAT);
	


		if(!vista_tio)
		dibuja_tetera(0,0);
		dibuja_tetera2(1,1);
  		dibuja_tetera(2,2);
 		dibuja_tetera(3,3);
 		dibuja_tetera(4,1);
  		dibuja_tetera(5,2);
 		dibuja_tetera(6,3);
  		dibuja_tetera(7,2);
  		
        dibuja_lineas_teteras();
  	glPopMatrix();

	glClear(GL_DEPTH_BUFFER_BIT);
	
glColorMask(GL_FALSE,GL_TRUE,GL_TRUE,GL_TRUE);
glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
		glFrustum((-0.7)+posf-0.04,0.7+posf-0.04,-0.7,0.7,1,40);
glMatrixMode(GL_MODELVIEW);

 
	glPushMatrix();
    	if(!vista_tio)
		{
		
			gluLookAt(obs[0]+DOCULAR,obs[1],obs[2],ref[0]+DOCULAR,ref[1], ref[2]+1.5, 0.0, 1.0, 0.0);

		}
		else
		{
		TrayectoriaTetera(tetera[0],vecx,0.4);
		
        m_vector_prod_3D(vecx,vecy,vecz);
			for(i=0;i<3;i++)
			{
   				 	mt[i][0]=vecz[i];
					mt[i][1]=vecy[i];
					mt[i][2]=-vecx[i];
					mt[3][i]=0;
					m2[3][i]=-tetera[0][i];

			}
		  glMultMatrixf((GLfloat*)mt);
		  glMultMatrixf((GLfloat*)m2);
		  }
		glDisable(GL_CULL_FACE);	
 		glShadeModel(GL_FLAT);
	


		if(!vista_tio)
		dibuja_tetera_st(0,0);
		dibuja_tetera_st(1,1);
  		dibuja_tetera_st(2,2);
 		dibuja_tetera_st(3,3);
 		dibuja_tetera_st(4,1);
  		dibuja_tetera_st(5,2);
 		dibuja_tetera_st(6,3);
  		dibuja_tetera_st(7,2);
  		
        dibuja_lineas_teteras();
  	glPopMatrix();
glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);

  glutSwapBuffers();

}
static void draw_scene_antialias(void)
{
  GLfloat dist = 5.0;
  GLdouble top,bottom,xizq,xder;
  GLfloat eyex, eyey, eyez;
  GLfloat mat[4][3]= {
	{0,0,1},
	{0,1,0},
	{1,0,0},
	{1,1,0}};
	GLfloat mivista[16]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
    GLfloat m2[4][4]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
	GLfloat mt[4][4]={
		{0.7,0.7,0.0,0},
		{-0.7,0.7,0,0},
		{0,0,1,0},
		{1,1,0,1}};
	GLfloat vecx[3]={1,0,0};
	GLfloat vecy[3]={0,1,0};
	GLfloat vecz[3]={0,0,1};
	GLfloat tras[3]={1,0,0};

	
  int i,j;
  long zmax;

 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glEnable(GL_DEPTH_TEST);
  top=1*tan(fov*0.01745*0.5);
   bottom=-top;
   xizq=bottom*aspecto;
   xder=top*aspecto;
	


	glReadBuffer(GL_BACK);
	
   glClear(GL_ACCUM_BUFFER_BIT);
   for(i=0;i<8;i++)
   {
        glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		desplaza_frustum_antialias(xizq,xder, bottom, top,1, 40,vec_desp[i][0], vec_desp[i][1]);
		
		glGetIntegerv(GL_DEPTH_CLEAR_VALUE,&zmax);
				glClearDepth(zmax);

   				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
   		
	if (!i)
		delta_tiempo=0.2;
	else
		delta_tiempo=0;

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
  	glPushMatrix();
    	if(!vista_tio)
		{
		
			gluLookAt(obs[0],obs[1],obs[2],ref[0],ref[1], ref[2], 0.0, 1.0, 0.0);

		}


		else
		{
		TrayectoriaTetera(tetera[0],vecx,delta_tiempo);
		
        m_vector_prod_3D(vecx,vecy,vecz);
			for(i=0;i<3;i++)
			{
   				 	mt[i][0]=vecz[i];
					mt[i][1]=vecy[i];
					mt[i][2]=-vecx[i];
					mt[3][i]=0;
					m2[3][i]=-tetera[0][i];

			}
	
		  glMultMatrixf((GLfloat*)mt);
		  glMultMatrixf((GLfloat*)m2);
		  }
       
		glDisable(GL_CULL_FACE);	
 		glShadeModel(GL_FLAT);
	
	

		if(!vista_tio)
		dibuja_tetera(0,0);
		dibuja_tetera2(1,1);
  		dibuja_tetera(2,2);
 		dibuja_tetera(3,3);
 		dibuja_tetera(4,1);
  		dibuja_tetera(5,2);
 		dibuja_tetera(6,3);
  		dibuja_tetera(7,2);
  		
        dibuja_lineas_teteras();
  	glPopMatrix();

   	
		glAccum(GL_ACCUM, 1.0f/8.0);

	}
   glAccum(GL_RETURN, 1.0f);
	
  glutSwapBuffers();

}
static void draw_scene_estela(void)
{
  GLfloat dist = 5.0;
  GLfloat grado[5]={0.025,0.05,0.125,0.25,0.55};
  GLdouble top,bottom,xizq,xder;
  GLfloat eyex, eyey, eyez;
  GLfloat mat[4][3]= {
	{0,0,1},
	{0,1,0},
	{1,0,0},
	{1,1,0}};
	GLfloat mivista[16]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
    GLfloat m2[4][4]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
	GLfloat mt[4][4]={
		{0.7,0.7,0.0,0},
		{-0.7,0.7,0,0},
		{0,0,1,0},
		{1,1,0,1}};
	GLfloat vecx[3]={1,0,0};
	GLfloat vecy[3]={0,1,0};
	GLfloat vecz[3]={0,0,1};
	GLfloat tras[3]={1,0,0};

	
  int i,j;
  long zmax;

 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glEnable(GL_DEPTH_TEST);
  top=1*tan(fov*0.01745*0.5);
   bottom=-top;
   xizq=bottom*aspecto;
   xder=top*aspecto;
	


	glReadBuffer(GL_BACK);
	
   glClear(GL_ACCUM_BUFFER_BIT);
   for(i=0;i<5;i++)
   {
  
   				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
   		
	/*if (i==3)
		delta_tiempo=0.2;
	else*/
		delta_tiempo=0.04;

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
  	glPushMatrix();
    	if(!vista_tio)
		{
		
			gluLookAt(obs[0],obs[1],obs[2],ref[0],ref[1], ref[2], 0.0, 1.0, 0.0);

		}


		else
		{
		TrayectoriaTetera(tetera[0],vecx,delta_tiempo);
		
        m_vector_prod_3D(vecx,vecy,vecz);
			for(i=0;i<3;i++)
			{
   				 	mt[i][0]=vecz[i];
					mt[i][1]=vecy[i];
					mt[i][2]=-vecx[i];
					mt[3][i]=0;
					m2[3][i]=-tetera[0][i];

			}
	
		  glMultMatrixf((GLfloat*)mt);
		  glMultMatrixf((GLfloat*)m2);
		  }
       
		glDisable(GL_CULL_FACE);	
 		glShadeModel(GL_FLAT);
	
	

		if(!vista_tio)
		dibuja_tetera(0,0);
		dibuja_tetera2(1,1);
  		dibuja_tetera(2,2);
 		dibuja_tetera(3,3);
 		dibuja_tetera(4,1);
  		dibuja_tetera(5,2);
 		dibuja_tetera(6,3);
  		dibuja_tetera(7,2);
  	//	if(i==3)
        dibuja_lineas_teteras();
  	glPopMatrix();

   	
		glAccum(GL_ACCUM, grado[i]);

	}
   glAccum(GL_RETURN, 1.0f);
	
  glutSwapBuffers();

}
static void 
draw_scene(void)
{
  GLfloat dist = 5.0;
  GLfloat eyex, eyey, eyez;
  GLfloat mat[4][3]= {
	{0,0,1},
	{0,1,0},
	{1,0,0},
	{1,1,0}};
	GLfloat mivista[16]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
    GLfloat m2[4][4]={1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
	GLfloat mt[4][4]={
		{0.7,0.7,0.0,0},
		{-0.7,0.7,0,0},
		{0,0,1,0},
		{1,1,0,1}};
	GLfloat vecx[3]={1,0,0};
	GLfloat vecy[3]={0,1,0};
	GLfloat vecz[3]={0,0,1};
	GLfloat tras[3]={1,0,0};

	
  int i,j;

 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	glEnable(GL_DEPTH_TEST);
  	glPushMatrix();
    	if(!vista_tio)
		{
		
			gluLookAt(obs[0],obs[1],obs[2],ref[0],ref[1], ref[2], 0.0, 1.0, 0.0);

		}
		else
		{
		TrayectoriaTetera(tetera[0],vecx,delta_tiempo);
		
        m_vector_prod_3D(vecx,vecy,vecz);
			for(i=0;i<3;i++)
			{
   				 	mt[i][0]=vecz[i];
					mt[i][1]=vecy[i];
					mt[i][2]=-vecx[i];
					mt[3][i]=0;
					m2[3][i]=-tetera[0][i];

			}
		  glMultMatrixf((GLfloat*)mt);
		  glMultMatrixf((GLfloat*)m2);
		  }
          glGetFloatv(GL_MODELVIEW_MATRIX,(GLfloat *)m2);
			printf("\nMatrizVision \n");
			for(i=0;i<4;i++)
			{

				printf("\n");
				for(j=0;j<4;j++)	
				printf("%f\t",m2[j][i]);

			}
	glDisable(GL_CULL_FACE);	
 		glShadeModel(GL_FLAT);
	

		if(!vista_tio)
		dibuja_tetera(0,0);
		dibuja_tetera2(1,1);
  		dibuja_tetera(2,2);
 		dibuja_tetera(3,3);
 		dibuja_tetera(4,1);
  		dibuja_tetera(5,2);
 		dibuja_tetera(6,3);
  		dibuja_tetera(7,2);
  		
        dibuja_lineas_teteras();
  	glPopMatrix();

  glutSwapBuffers();

}
/* ARGSUSED1 */
void 
key(unsigned char key, int x, int y)
{
  switch (key) {
  case 27:
    exit(0);

    break;
	case 'm':
		vista_tio=!vista_tio;
		break;
	case 'a':
		eje_aspect=!eje_aspect;
		break;
	case 's':
		fov+=5;
		actualiza_perspectiva();
		break;
	case 'x':
		fov-=5;
		actualiza_perspectiva();
		break;
	case 'f':
		frustrum=!frustrum;
		actualiza_perspectiva();
		break;
	
	case 'd':
		posf+=0.1;
		actualiza_perspectiva();
		break;
	case 'c':
		posf-=0.1;
		actualiza_perspectiva();
		break;
	case 'p':
		if(delta_tiempo!=0)
				delta_tiempo=0;
		else
			delta_tiempo=0.2;
		break;

	case 'q':
		obs[2]-=0.1;
		break;
	case 'w':
		obs[2]+=0.1;
		break;
	case '1':
			tipo_escena=0;
		break;

	case '2':
			tipo_escena=1;
		break;
	case '3':
			tipo_escena=2;
		break;
	case '4':
			tipo_escena=3;
		break;
	case '5':
			tipo_escena=4;
		break;



  }
}

/* ARGSUSED1 */
void
special(int key, int x, int y)
{
  switch(key) {
  case GLUT_KEY_UP:
    xrot += 3.0;
#ifndef USE_ZBUFFER
    if (xrot > 180)
      xrot = 180;
#endif
    break;
  case GLUT_KEY_DOWN:
    xrot -= 3.0;
#ifndef USE_ZBUFFER
    if (xrot < 0)
      xrot = 0;
#endif
    break;
  case GLUT_KEY_LEFT:
    yrot += 3.0;
    break;
  case GLUT_KEY_RIGHT:
    yrot -= 3.0;
    break;
  default:
    return;
  }
  glutPostRedisplay();
}

static void 
idle(void)
{
 /* spin += 2.0;
  yrot += 3.0;  */
  glutPostRedisplay();
}

void 
visible(int vis)
{
  if (vis == GLUT_VISIBLE)
    glutIdleFunc(idle);
  else
    glutIdleFunc(NULL);
}

int
main(int argc, char *argv[])
{
  glutInitWindowSize(400, 400);
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB| GLUT_DEPTH| GLUT_ACCUM);
  
  glutCreateWindow("Pruebas Camara");
  glutReshapeFunc(reshape);
  glutDisplayFunc(draw_scene_general);
  glutKeyboardFunc(key);
  glutSpecialFunc(special);
  glutVisibilityFunc(visible);

  init();

  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}

