
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
//#include <sys/time.h>
#include <sys/timeb.h>
#include <windows.h>
#include <gl/gl.h>
#include <gl/glut.h>

#define FALSO 0
#define VERDADERO 1

/** MANEJO PROGRAMA:

   

**/

#define M_PI 3.1416
float posx=0;
	float posy=0;
	float posz=-2;//Posicion punto de vista
	float pnear=0.1f;
	float pfar=5.0;//Posicion plano near y far
	int wide=0;
	int height=0;

int ancho=400, alto=300;	/*Ancho y alto de la ventana*/
char animacionActivada = FALSO; /*Activar o desactivar giro de la ventana*/
int material = 0;		/*Material actual*/

double lastTime = 0.0;		/*Tiempo en el que se dibujo el fotograma anterior*/
double rotationRate = 360.0 / 8.0;	/*Velocidad de rotacion del cilindro*/
double rotation = 0.0;		/*Angulo que tiene el cilindro en cada momento*/

/****************** INICIALIZACION CONTEXTO GRAFICO GL *******************/
/****************************************************************
Funcion en la que inicializamos el contexto de disporsitivo:
activamos el color de fondo, iluminaciones o calculos preliminares
Parametros: 
Return:nada
***************************************************************/
//static void inicio(void)
void gl_inicializa(void)
{
    GLfloat lightAmb[4] = { 1.0f, 0.2f, 0.2f, 1.0f };
    GLfloat lightPos[4] = { 1.5f, 1.5f, 1.5f, 1.0f };

	glClearColor(0.0f, 0.0f, 0.0f, 1.0f ); //Elige el color de fondo de la ventana

	//ILUMINACIN
   /* glDisable(GL_LIGHTING);    DESACTIVAR ILUMINACION*/
    glEnable(GL_LIGHTING);   /*Activa iluminacion*/		
    glEnable(GL_LIGHT0);     /*Activamos una luz*/	
    glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmb);	/*Propiedades de la luz*/
    glLightfv(GL_LIGHT0, GL_POSITION, lightPos); /*Posicion de la luz*/
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);	

 
	glDepthFunc(GL_LESS);
    glEnable(GL_DEPTH_TEST);/*Activa test de profundidad: para saber qu poligonos hay delante
			     y eliminar superficies ocultas*/

    //glEnable(GL_CULL_FACE); Activar culling para que solo dibuje una cara
    //glCullFace(GL_FRONT); Por defecto el front


    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE); /*Modo de dibujo de los poligonos:
						cara externa e interna con lineas*/
   //glPolygonMode(GL_FRONT, GL_LINE); Una cara con lineas y otra rellena
   //glPolygonMode(GL_BACK, GL_FILL);
    
}

/*************************** FUNCION DIBUJO CILINDRO **********************/
/*******************************************************************
Utilizaremos una tira de triangulos para generar el cilindro
*********************************************************************/
static void
dibuja_cilindro(void)
{
    int numSides = 20;
    double radius = 0.7;
    double stepSize = 2.0*M_PI / numSides;
    int i;

    GLfloat matAmbDiff1[4] = { 0.30f, 0.40f, 0.80f, 1.0f };
    GLfloat matAmbDiff2[4] = { 0.80f, 0.40f, 0.30f, 1.0f };

/*Material asignado*/

    if (material==0)
       glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, matAmbDiff1);
    else
       glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, matAmbDiff2);


    glBegin(GL_TRIANGLE_STRIP);
    for (i=0; i<=numSides; ++i) 
	{
		double a = i * stepSize;
		GLfloat x = (float)cos(a);
		GLfloat y = (float)sin(a);

		glNormal3f(x, y, 0.0);
		glColor4f(i*0.1f,0.2f,0.7f, 0.9f); /*INMA: PONER COLOR Y DESACTIVAR LA ILUMINACION*/
		glVertex3f(x * radius, y * radius, 0.7f);
		glNormal3f(x, y, 0.0); 
		glVertex3f(x * radius, y * radius, -0.7f);
    }
    glEnd();
}

/************************ FUNCION DIBUJO ESCENA ***********************/

static void gl_redibujar(void)
{
/*DEFINIMOS CARACTERICAS DE DONDE ESTA Y COMO VE EL OBSERVADOR*/
	/*Definimos el area de dibujo (Viewport) dentro de la ventana (en este caso
	le decimos que el area es toda la ventan*/
  //  glViewport(0,0,ancho,alto); /*INMA: PROBAR A CAMBIAR ESTO: hacerlo mayor y menos
			//	que la ventana*/


//	glMatrixMode(GL_MODELVIEW);
//	glLoadIdentity();

	/*Giramos el sistema de coordenadas : como si giraramos toda la escena*/
    glPushMatrix();	/*Creamos una nueva matriz (la rotacion es desde el angulo 0)*/
    glRotated(rotation, 0, 1, 0);

	/*Definimosla proyeccion: perspectiva:como se proyectan los datos de los objetos
	sobre nuestra ventana 2D*/
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();/*Empezamos con matriz identidad:no hay perspectiva*/
    gluPerspective(60.0, (float)ancho/alto, .1, 5.0); /*Ponemos matriz de perspectiva
		60: angulo de vision
		ancho/alto: aspecto. Si queremos que los objetos no se distorsionen
			cuando la ventana es mas ancha hay que cambiar el aspecto segun
			las proporciones de la ventana.
		0.1:distancia cercana (a menor distancia de 0.1 no se dibuja nada
		5.0 : distancia lejana ( a mayor distanciano se dibuja nada*/
    /*glFrustum(-2, 2, -1, 1, 1, 3);*/  /* ancho, alto, prof */
    glMatrixMode(GL_MODELVIEW);

/*Dibujamos en el buffer que no se ve(back) y cuando ya esta lo visualizamos en el que
se ve(front)*/
    glDrawBuffer(GL_BACK);
	/*Antes de dibujar limpiamos el buffer de color y la memoria de profundidad*/
   // glClearColor(0.1,0.5,0.6,1.0);/*INMA:poner color de fondo*/
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);/*Limpiar el buffer de color y el
						de profundidad*/              
	/*Dibujamos el objeto*/
    dibuja_cilindro();

    glPopMatrix();
    
    /*INMA:PROBAR A DIBUJAR DOS COSAS EN EL VIEWPORT: poner todo 
     * el codigo de arriba otra vez,  cambiando el viewport por la mitad
     * de la escena glViewport(ancho/2, 0, ancho/, alto);
     * y eliminando del segundo trozo los glClear,  y cambiado el aspecto
     * en gluperspective
     */

    
    glutSwapBuffers(); /*Pasamos el buffer back delante*/
}


double getTime(void)
{
 _timeb timeptr;

	_ftime(&timeptr);

   // gettimeofday(&time);
    return ((double) timeptr.time + (double) timeptr.millitm * 1E-3	);
}

/***********************************************************
Funcion a la que llama el sistema cuando no tiene nada que hacer
Lo que hacemos es actualizar el angulo de giro segun el tiempo que 
ha transcurrido desde el ultimofotograma
***********************************************************/
static void gl_actualizar(void)
{
if (animacionActivada)
{
    double currentTime = getTime(); /*Miratiempo actual*/
    double elapsed = currentTime - lastTime; /*Lo compara con el del ultimo*/

    lastTime = currentTime;

	/*Actualiza la rotacion segun el tiempo transcurrido*/
	/*Si eltiempo transcurrido es muy grand??*/
//printf("ELAPSED %f\n",elapsed);
    rotation += rotationRate * ((elapsed <= 1.0) ? elapsed : 1.0);
    if (rotation >= 360) rotation -= 360;

    glutPostRedisplay();
    }
    
}
/*******************************************
Se le pasa el nuevo tamao y lo almacena en las 
variables globales. Luego llama a redibujar
**********************************************/
static void gl_cambia_tam(int anchura, int altura)
{
   
	GLfloat nRange = 120.0f;

	// Prevent a divide by zero
	//Almacenamos el ancho y el alto en dos variables globales
	wide=anchura;
	height=altura;

	if(height == 0)
		height = 1;

		/*DEFINIMOS CARACTERICAS DE DONDE ESTA Y COMO VE EL OBSERVADOR*/
	/*Definimos el area de dibujo (Viewport) dentro de la ventana (en este caso
	le decimos que el area es toda la ventana.
	Los dos primeros parametros son x,y: esquina inferior izquierda del area
	de dibujo, y los dos siguientes el ancho y alto.*/
	glViewport(0, 0, wide, height);

	

	/*Definimos la proyeccion: perspectiva:como se proyectan los datos de los objetos
	sobre nuestra ventana 2D*/
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	gluPerspective(60.0, (float)wide/height, pnear, 30); //Ponemos matriz de perspectiva
		//  60: angulo de vision
		//  ancho/alto: aspecto. Si queremos que los objetos no se distorsionen
		//	cuando la ventana es mas ancha hay que cambiar el aspecto segun
		//	las proporciones de la ventana.
		//  pnear:distancia cercana (a menor distancia de 0.1 no se dibuja nada
		//  pfar : distancia lejana ( a mayor distanciano se dibuja nada
		//  pnear y pfar son dos variables globales de este mdulo

	/*Inicializamos posicion del punto de vista*/
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	//Es equivalente hacer un traslate o rotate aqui a hacer gllookat
    glTranslatef(posx, posy, posz); 
	//gluLookAt(0,0,10,0,0,0,0,1,0);


    glutPostRedisplay();
}

/************************************************************
Funcion de callback del teclado
**************************************************************/
static void teclado_CB(unsigned char key, int x, int y)
{
/*inma*/ static int mode=0;
    switch (key) 
	{
      case 'm': /*Cambiamos material*/
		material = (material==0)? 1:0;
		glutPostRedisplay(); /*Envia evento de redibujado despues de hacer un cambio*/
	  break;
      case 'r': /*Cambiamos modo de rellenado de los poligonos: relleno*/
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
		glutPostRedisplay();
	  break;
      case 'l': /*Pone en modo de lineas*/
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
		glutPostRedisplay();
	  break;
      case 'a': /*Activa o desactiva la animacion*/
		animacionActivada = !animacionActivada;
		glutPostRedisplay();
	   break;
      case 'f': /*Cambia modo flat*/
		if(mode==0)
		{
			glShadeModel(GL_FLAT);
			mode=1;
		}
		else
		{
			glShadeModel(GL_SMOOTH);
			mode=0;	    
		}
	   break;
  
      case 's':
		exit(0);
    }
}

int main(int argc, char **argv)
{
    GLenum type;


    glutInit(&argc, argv); /*Inicializamos la libreria*/
	/*Antes de abrir la ventana hay que decir cmo queremos configurar la memoria
	grafica: utilizamos truecolor(rgb), luego doble buffer: dibujamos en un buffer
	y luego lo presentamos en la ventana, para que as no se vea el rellenado,
	GLUT_DEPTH:reservamos memoria para el buffer de profundidad:sirve para hacer
	el teste de profundidad*/
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	/*Inicializa el tamanyo de la ventana*/
    glutInitWindowSize(ancho, alto);
	/*Abrimos la ventana con un titulo*/
    glutCreateWindow("Practica Ejemplo");

    //inicio();
	gl_inicializa();/*Funcion que inicializa el contexto grafico dela OPENGL*/

	/*Funciones para la gestion de eventos: decimos que funciones son llamadas
	cuando ocurren determinados eventos*/
    glutReshapeFunc(gl_cambia_tam);/*Funcion que sera llamada cuando cambie 
								   el tamanyo de la ventana*/
    glutKeyboardFunc(teclado_CB);  /*Funcion que responde a los eventos del teclado*/
    glutDisplayFunc(gl_redibujar); /*Funcion de redibujado*/	
    glutIdleFunc(gl_actualizar);   /*Funcion que se llama cuando no hay nada mas que hacer
				Lo normal es utilizar esta funcion para calcular, por ejemplo
				como tiene que dibujar el objeto en el siguiente paso*/
    glutMainLoop();		/*Bucle de lectura de eventos:lee eventos y va llamando a las
				funciones anteriormente declaradas*/

	/*Estas funciones anteriores las podemos llamar como queramos pero tienen
	que tener unos determinado argumentos*/
}
